"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("./config");
const metadata_1 = require("./metadata");
function Endpoint(method, path, extraConfig = {}) {
    return (target, key, descriptor) => {
        const config = metadata_1.default.getFunction(target.constructor, key);
        if (!config) {
            throw new config_1.MissingHandlerError(`Missing @Handler decorator for ${key}`);
        }
        if (!config.events) {
            config.events = [];
        }
        config.events.push({
            http: Object.assign({ method, path }, extraConfig),
        });
        return descriptor;
    };
}
exports.Endpoint = Endpoint;
