"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const metadata_1 = require("./decorators/metadata");
__export(require("./decorators"));
function addServices(parentExports, services) {
    if (module.parent && module.parent.exports && Object.keys(module.parent.exports).length) {
        Object.assign(parentExports, module.parent.exports, { default: undefined });
        return;
    }
    return services.reduce((config, Service, i) => (Object.assign({}, config, getServiceConfig(parentExports, Service, i))), {});
}
exports.addServices = addServices;
function getServiceConfig(parentExports, Service, i) {
    return metadata_1.default.getFunctions(Service).reduce((serviceConfig, [functionName, config]) => {
        const localName = `service${i}_${functionName}`;
        parentExports[localName] = (...args) => {
            const service = new Service();
            return service[`__invoke_${functionName}`](...args);
        };
        return Object.assign({}, serviceConfig, { [functionName]: Object.assign({}, config, { handler: `functions.${localName}` }) });
    }, {});
}
