"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable import/no-dynamic-require */
/* eslint-disable global-require */
const path = require("path");
const ts = require("typescript");
const tsConfig = {
    noEmitOnError: false,
    noImplicitAny: false,
    lib: ['es2015'],
    outDir: '.decorators',
    target: ts.ScriptTarget.ES5,
    module: ts.ModuleKind.CommonJS,
    moduleResolution: ts.ModuleResolutionKind.NodeJs,
    experimentalDecorators: true,
    allowJs: true,
};
exports.default = (servicePath) => __awaiter(this, void 0, void 0, function* () {
    ts.createProgram([path.join(servicePath, 'functions.ts')], tsConfig).emit();
    const slsConfig = require(path.join(servicePath, '.decorators/functions.js')).default;
    return slsConfig;
});
